!c Description:
!c   LU ʬˡõ դ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-05-30    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_ludcmp
  interface
     
     subroutine ludcmp(A, singular, order, scale_factor)
       real(8), intent(inout)  :: A(:,:)
       real(8), intent(out)    :: scale_factor(:,:)
       integer(8), intent(out) :: order(:,:)
       logical, intent(out)    :: singular
     end subroutine ludcmp

  end interface
end module interface_ludcmp




subroutine ludcmp(A, singular, order, scale_factor)
  real(8), intent(inout)  :: A(:,:)
  real(8), intent(out)    :: scale_factor(:,:)
  integer(8), intent(out) :: order(:,:)
  logical, intent(out)    :: singular
  
  integer(8)              :: n, i, j, k
  real(8)                 :: pivotinv, tol
  integer(8)              :: p_loc(2)
  
  
  n = size(A, 1)
  !Υ
  scale_factor(:,1) = 1.0d0 / maxval(abs(A), 2)
  do j = 1, n
     A(:,j) = A(:,j) * scale_factor(:,1)
  end do

  !Υ
  scale_factor(:,2) = 1.0d0 / maxval(abs(A), 1)
  do j = 1, n
     A(:,j) = A(:,j) * scale_factor(j,2)
  end do
  
  tol = epsilon(A) * 1.0d1
  singular = .false. 
  order(:,1) = (/(i, i = 1, n)/)
  order(:,2) = order(:,1)

  do i = 1, n
     !
     p_loc(1:2) = maxloc(abs(A(i:n,i:n))) + i - 1
     j = p_loc(1)
     k = p_loc(2)
     if (abs(A(j,k)) <= tol) then 
        singular = .true.
!        write(*,*) n, "γ", i - 1, "Ȥʤޤ."
        exit
     end if

     !Ը
     if (j /= i) call exchange(A(i,:), A(j,:), order(i,1), order(j,1))
     if (k /= i) call exchange(A(:,i), A(:,k), order(i,2), order(k,2))

     !ݤФ
     pivotinv = 1.0d0 / A(i,i)
     do k = i + 1, n
        A(i,k) = A(i,k) * pivotinv
        A(i+1:n,k) = A(i+1:n,k) - A(i+1:n,i) * A(i,k)
     end do
  end do

  
contains
  
  
  subroutine exchange(array_a, array_b, scale_i, scale_j)
    real(8)    :: array_a(:)
    real(8)    :: array_b(:)
    integer(8) :: scale_i
    integer(8) :: scale_j
    real(8), allocatable  :: work(:)
    integer(8)            :: tmp
    
    allocate(work(size(array_a, 1)))
    work = array_a
    array_a = array_b
    array_b = work
    tmp = scale_i
    scale_i = scale_j
    scale_j = tmp
  end subroutine exchange
  
  
end subroutine ludcmp
