!c Description:
!c   ʿվ狼¸ߤǤʤؼ򥫥å
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_chk_equiv
  interface
     
     subroutine chk_equiv(temp, pres, property, ssw, sw)
       use prm_type, only: type_property
       real(8), intent(in)               :: temp
       real(8), intent(in)               :: pres
       logical, intent(out), allocatable :: ssw(:) 
       logical, intent(out)              :: sw
       type(type_property), intent(in)   :: property(:)
     end subroutine chk_equiv

  end interface
end module interface_chk_equiv




subroutine chk_equiv(temp, pres, property, ssw, sw)
  use prm_type, only: type_property
  use prm_phys, only: pres_ref, gasr
  use interface_gibbs_energy
  use interface_name_cnd2gas
  use interface_name2num

  implicit none
  real(8), intent(in)               :: temp
  real(8), intent(in)               :: pres
  logical, intent(out), allocatable :: ssw(:) 
  logical, intent(out)              :: sw
  type(type_property), intent(in)   :: property(:)

  real(8), allocatable              :: mol(:)
  real(8), allocatable              :: mu0(:)
  real(8)                           :: mu
  integer(8), allocatable           :: num(:)    
  integer(8)                        :: N
  integer(8)                        :: s, t
  character(80)                     :: name


!!!
!!!
!!!
  N = size(property, 1)
  if (allocated(ssw)) deallocate(ssw)
  allocate(ssw(N), mol(N), num(N))
  ssw = .true.; sw = .false.  
  mol = 1.0d0   ! ̤׻
  num = 0 

  
!!!
!!!ɸಽإݥƥ󥷥η׻
!!!
  call gibbs_energy(temp, pres, mol, property, mu0=mu0)

  
!!!
!!!, б뵤ֹ
!!!  
  do s = 1, N
     if (property(s)%phase == 1) cycle
     call name_cnd2gas(property(s)%name, name)
     call name2num(name, property, num(s))
  end do

  
!!!
!!!ȸ꤬¸ߤȽ
!!!
  cut: do s = 1, N - 1
     if (num(s) == 0) cycle cut !䲽ȿʪ num  0
     if (property(s)%phase == 2 .AND. count(property%phase == 2) /= 1) &
          & cycle cut
     if (property(s)%phase == 3 .AND. count(property%phase == 3) /= 1) &
          & cycle cut
     
     do t = s + 1, N
        if(num(s) == num(t)) then 
           if (mu0(s) > mu0(t)) then  
              ssw(s) = .false. 
              sw = .true.
!              write(*,*) property(t)%name, "is true"
!              write(*,*) property(s)%name, "is false"
           else
              ssw(t) = .false. 
              sw = .true. 
!              write(*,*) property(t)%name, "is false"
!              write(*,*) property(s)%name, "is true"
           end if
        end if
        
     end do
  end do cut
!  write(*,*) "ssw", ssw


!!!
!!!ϱȸ꤬¸ߤȽ
!!!
  cut2: do s = 1, N - 1
     if (property(s)%phase /= 2) cycle cut2 !ϱʳ̵

     cut2_1: do t = s + 1, N
        if (property(t)%phase /= 4) cycle cut2_1 !Žʳ̵
        if (num(t) == 0) cycle cut2_1            !ȿβʪ̵
        if(num(s) == num(t)) then   
           if (mu0(s) < mu0(t)) then  
              !ϱβإݥƥ󥷥Ϻ缡Ǿʤ
              ssw(t) = .false.    
              sw = .true.
!              write(*,*) property(s)%name, "is true"
!              write(*,*) property(t)%name, "is false"
           end if
        end if
       
     end do cut2_1
  end do cut2
!  write(*,*) "ssw", ssw


!!!
!!!絤Τȸ꤬¸ߤȽ
!!!
  cut3: do s = 1, N - 1
     if (property(s)%phase /= 1) cycle cut3 !ʳ̵
     
     cut3_1: do t = s + 1, N
        if (property(t)%phase /= 4) cycle cut3_1 !Žʳ̵
        if (num(t) == 0) cycle cut3_1            !ȿβʪ̵

        if(s == num(t)) then   
           mu = mu0(s) + gasr * temp * dlog(pres / pres_ref)

           if (mu < mu0(t)) then  
              !βإݥƥ󥷥Ϻ缡Ǿʤ
              ssw(t) = .false.    
              sw = .true.
!              write(*,*) property(s)%name, "is true"
!              write(*,*) property(t)%name, "is false"
           end if
        end if
        
     end do cut3_1
  end do cut3
!  write(*,*) "ssw", ssw
  
end subroutine chk_equiv
